(function() {

    openerp.widgetInstanceStatementTransfer = null;
    openerp.parentInstanceStatementTransfer = {};
    var QWeb = openerp.web.qweb;
    var instanceWeb = openerp.web;

    openerp.EiruStatementTransfer = openerp.Widget.extend({
        template: 'EiruStatementUtility.Transfer',
        id: undefined,
        buttons: undefined,
        bankStatement: [],
        accountJournal :[],
        statementOpen: [],

        /* init */
        init: function(parent) {
            this._super(parent);
            this.buttons = parent.$buttons;
        },
        /* start */
        start: function () {
            var self = this;
            this.$el.click(function(){
                self.fetchInitial();
            });
            self.buttons.click(function(e) {
                /* C (Crear) */
                if (e.target.accessKey === 'C')
                    self.$el.css('display','none');
                /* E (Editar) */
                if (e.target.accessKey === 'E')
                    self.$el.css('display','none');
                /* S (Guarrdar) */
                if (e.target.accessKey === 'S')
                    self.$el.css('display','flex');
                /* D (Cancelar) */
                if (e.target.accessKey === 'D')
                    self.$el.css('display','flex');
            });
        },
        /* Actualizar Id de la visat actual  */
        updateId: function(id) {
            var self = this;
            self.id = id;
        },
        /* Reload Page*/
        reloadPage: function() {
             openerp.parentInstanceStatementTransfer.reload();
        },
        /* Description: Función para remover el modal */
        removeModal: function() {
            $('.expired-account-modal').remove();
            $('.modal-backdrop').remove();
        },
        /* Método inicial  */
        fetchInitial: function() {
            var self = this;
            self.fetchBankStatement(self.id).then(function(bankStatement){
                return bankStatement;
            }).then(function(bankStatement){
                self.bankStatement = bankStatement;
                return self.fetchAccountJournal(self.id);
            }).then(function(accountJournal){
                self.accountJournal = accountJournal;
                return self.showModalTransfer();
            });
        },
        /* Account bank Statement */
        fetchBankStatement: function(id) {
            var bankStatement = new instanceWeb.Model('account.bank.statement');
            return bankStatement.call('get_account_bank_statement_utility',[id], {
                context: new instanceWeb.CompoundContext()
            });
        },
        /* Account Journal*/
        fetchAccountJournal: function(id) {
            var accountJournal = new instanceWeb.Model('account.bank.statement');
            return accountJournal.call('get_account_journal_utility',[id], {
                context: new instanceWeb.CompoundContext()
            });
        },
        /* Get statement Journal */
        getStatementJournal(id) {
            var self = this;
            var journal = _.filter(self.accountJournal, function(item){
                return  item.id === id ;
            });
            return _.flatten(_.map(journal, function(map){
                return map.statementJournal;
            }));
        },
        /* Save Statement transfer */
        statementCompletTransfers: function(values) {
            var bankStatementTransfer = new instanceWeb.Model('account.bank.statement');
            return bankStatementTransfer.call('statement_complet_transfers',[values], {
                context: new instanceWeb.CompoundContext()
            });
        },
        /*Modal  Transfer */
        showModalTransfer: function() {
            var self = this;
            var defer =$.Deferred();
            var results = true;
            var accountJournal =  self.accountJournal;

            accountJournal.unshift({'name': '', 'id': ''});

            var modal = QWeb.render('ModalStatementUtility.Transfer',{
                'journal': accountJournal
            });

            $('.openerp_webclient_container').after(modal);
            $('.expired-account-modal').modal();


            var statementAmount = $('.expired-account-modal').find('.statement-amount')             // Monto Disponible.
            var selectedJournal = $('.expired-account-modal').find('.selected-Journal')             // Journal.
            var statementOpen = $('.expired-account-modal').find('.statement-open')                 // Caja a Transferir.
            var amountTransfer = $('.expired-account-modal').find('.amount-transfer')               // Monto a Transferir.
            var amountTransferSymbol = $('.expired-account-modal').find('.amount-transfer-symbol')  // Symbolo del monto a Transferir.
            var refTransfer = $('.expired-account-modal').find('.ref-transfer')                     // Referencia de la Transferencia.
            /* Button */
            var buttonSave = $('.expired-account-modal').find('.button-save')

            selectedJournal.change(function(e) {
                statementOpen.empty();

                var statementJournal = self.getStatementJournal(parseInt(selectedJournal.val()));
                if (!!statementJournal.length)
                    statementOpen.append('<option value=""></option>');

                _.each(statementJournal, function(item) {
                    statementOpen.append('<option value="' + item.id + '">' + item.statementname + '</option>');
                })

            });

            statementAmount.val(self.bankStatement[0].amount)
            /*Click buttonSave*/
            buttonSave.click(function(e){
                /* Journal */
                if (!selectedJournal.val()) {
                    instanceWeb.notification.do_warn("Atencion", "Debes seleccionar un tipo de pago para continuar.");
                    selectedJournal.css('border-color','red');
                    selectedJournal.focus();
                    return false;
                }
                selectedJournal.css('border-color','#ccc');
                /* Statement Open */
                if (!statementOpen.val()) {
                    instanceWeb.notification.do_warn("Atencion", "Debes seleccionar la caja donde vas a transferir.");
                    statementOpen.css('border-color','red');
                    statementOpen.focus();
                    return false;
                }
                statementOpen.css('border-color','#ccc');

                /* ammount transfer*/
                // if (!amountTransfer.val()) {
                //     instanceWeb.notification.do_warn("Atencion", "Tienes que seleccionar un método de pago para continuar.");
                //     amountTransfer.css('border-color','red');
                //     amountTransfer.focus();
                //     return false;
                // }
                // amountTransfer.css('border-color','#ccc');

                /**Ref transfer*/
                if (!refTransfer.val()) {
                    instanceWeb.notification.do_warn("Atencion", "Debes de ingresar un motivo para la transferencia.");
                    refTransfer.css('border-color','red');
                    refTransfer.focus();
                    return false;
                }
                refTransfer.css('border-color','#ccc');

                statementTransfer = {
                    'statementOriginId': self.bankStatement[0].id,
                    'statementDestinyId': parseInt(statementOpen.val()),
                    'amountTransfer': 100000,
                    'refTransfer': refTransfer.val().trim(),
                    'journalID': parseInt(selectedJournal.val())
                }

                /* Save Payments */
                $('.expired-account-modal').find('.widget-content.widget-loading-payments').css('display','flex');
                self.statementCompletTransfers(statementTransfer).then(function(resultsTransfer) {
                    return resultsTransfer;
                }).then(function(resultsTransfer) {
                    self.reloadPage();
                    // $('.expired-account-modal').find('.widget-content.widget-loading-payments').css('display','none');
                    self.removeModal(e);
                    if (!resultsTransfer)
                        results = false;
                });

                defer.resolve(results);

            });
            /* Click Cerrar */
            $('.expired-account-modal').on('hidden.bs.modal', function(e) {
                results = false;
                defer.resolve(results);
                self.removeModal(e);
            });

            return defer;
        },
    });

    if (openerp.web && openerp.web.FormView) {
        openerp.web.FormView.include({
            load_record: function(record) {
                this._super.apply(this, arguments);

                if (this.model !== 'account.bank.statement')
                    return;

                openerp.parentInstanceStatementTransfer = this;

                if (openerp.widgetInstanceStatementTransfer) {
                    openerp.widgetInstanceStatementTransfer.updateId(record.id);
                    if (this.$el.find('.button-statement-transfer').length !== 0 )
                        return ;
                }

                if (this.$el.find('.button-statement-transfer').length !== 0 )
                    return;

                openerp.widgetInstanceStatementTransfer = new openerp.EiruStatementTransfer(this);
                var element =this.$el.find('.oe_form').find('.eiru-statement-utility');

                openerp.widgetInstanceStatementTransfer.appendTo(element[0]);
                openerp.widgetInstanceStatementTransfer.updateId(record.id);
            }
        });
    }
})();
